<?php
/**
 * @copyright	Copyright (C) 2010-2014 Juloa.com. All rights reserved.
 *  @license GNU General Public License version 3, or later
 */

// Check to ensure this file is included in Joomla!
defined('_JEXEC') or die( 'Restricted access' );

JHTML::_('behavior.framework');

JFactory::getDocument()->addScript(JURI::root().'images/com_adsmanager/plugins/calendar/calendar.js');
//JFactory::getDocument()->addScript(JURI::root().'media/com_booking/js/jquery.json-2.3.min.js');
JFactory::getDocument()->addStyleSheet(JURI::root().'images/com_adsmanager/plugins/calendar/calendar.css');
$style = "";
$listclasses = "";
if (isset($seasons)) {
	foreach($seasons as $season) {
		$style .=" .type".$season->id." { background-color:".$season->color.";}";
		$listclasses .= " type".$season->id;
	}
}

?>
<style>
<?php echo $style?>
</style>

<div>
	<div class="calendar_title"><?php echo JText::_('ADSMANAGER_CALENDAR')?></div>
	<div id="calendars">
		<div id="leftcalendar"></div>
		<div id="centercalendar"></div>
		<div id="rightcalendar"></div>	
		<div id="next">
			<img border="0" width="21" height="21" src="<?php echo JURI::base() ?>images/com_adsmanager/plugins/calendar/images/ad_scroll_forward.png">
		</div>
		<div id="previous">
			<img border="0" width="21" height="21" src="<?php echo JURI::base() ?>images/com_adsmanager/plugins/calendar/images/ad_scroll_back.png">
		</div>
		<div class="clear"></div>
	</div>
	<div class="calendrier_description_etape"><?php echo JText::_('ADSMANAGER_PRICES')?></div>
	<div id="calendarprices">
		<?php 
			if (isset($seasons)) {
			foreach($seasons as $season) { 
		?>
		<div class="price"><div class="icon type<?php echo $season->id?>">&nbsp;</div><div class="texte_champ_prix"><?php echo htmlspecialchars(JText::_($season->label))?> : 
		<span><?php echo htmlspecialchars($season->price) ?></span>
		</div></div>
		<?php } }?>

		<div class="price"><div class="icon dispo0" >&nbsp;</div><div class="texte_champ_prix"><?php echo JText::_('ADSMANAGER_OCCUPIED')?>
		</div></div>
		<div class="clear"></div>
	</div>
</div>
<script>
days = <?php echo json_encode($days); ?>;
dispodays = <?php echo json_encode($reservations) ?>;

function drawCalendar() {
	jQuery('#centercalendar').html(buildCalendar(currentMonth,currentYear));
	jQuery('#leftcalendar').html(buildCalendar(prevMonth,prevYear));
	jQuery('#rightcalendar').html(buildCalendar(nextMonth,nextYear));
	jQuery('.calendarview .tdDay').each(function() {   
		jQuery(this).removeClass('<?php echo $listclasses?>');
		day = jQuery(this).attr('day');
		if (day in days) {
			jQuery(this).addClass("type"+days[""+day]);
		}
		jQ(this).removeClass('dispo0 dispo1');
		if (day in dispodays) {
			jQ(this).addClass("dispo"+dispodays[day]);
		}
    });
}
var oD = new Date(); //DD replaced line to fix date bug when current day is 31st
computeDate(oD.getMonth()+1,oD.getFullYear());
drawCalendar();

jQuery('#next').click(function() {
	computeDate(currentMonth+3,currentYear);
	drawCalendar();
});
jQuery('#previous').click(function() {
	computeDate(currentMonth-3,currentYear);
	drawCalendar();
});
</script>