<?php
/**
 * @package		AdsManager
 * @copyright	Copyright (C) 2010-2014 Juloa.com. All rights reserved.
 *  @license GNU General Public License version 3, or later
 */

// Check to ensure this file is included in Joomla!
defined('_JEXEC') or die( 'Restricted access' );

require_once(JPATH_ROOT."/components/com_adsmanager/lib/core.php");

class AdsManagerMultipleSearchSelectPlugin {

	var $_db;
	
	public function getListDisplay($content,$field)
	{
		return null;
	}

	public function getDetailsDisplay($content,$field,$mode="details")
	{
		return null;
	}
	
	
	public function getFormDisplay($content,$field,$default=null)
	{
		return null;
	}
	
	public function getSearchFormDisplay($content,$field,$default=null)
	{
		$fieldid = $field->fieldid;
		
		$fieldname = $field->name;
		$value = @$content->$fieldname;

		
		$this->_db->setQuery( "SELECT * FROM #__adsmanager_field_values WHERE fieldid='".(int)$field->fieldid."' ORDER BY ordering ASC" );
		$existingvalues = $this->_db->loadObjectList('fieldvalue');
		
		$return = '<select id="'.htmlspecialchars($fieldname).'" name="'.htmlspecialchars($fieldname).'[]" multiple >';
		foreach($existingvalues as $val) {
			if ($value && in_array($val->fieldvalue,$value)) {
				$checked = "selected";
			} else {
				$checked = "";
			}
			$return .= '<option value="'.htmlspecialchars($val->fieldvalue).'" '.$checked.'>'.htmlspecialchars($val->fieldtitle).'</option>';
		}
		$return .= '</select>';

		return $return;
	}
	
	public function getSqlFilter($field,$filter) {
		$sql = "";
		$sqls =array();
		if ($filter != null) {
			$fieldnames = @$field->options->fieldnames;

			foreach($filter as $term) {	
				$term = $this->_db->Quote($term);
				$sqls[] = " MATCH (".$fieldnames.") AGAINST (".$term." IN BOOLEAN MODE) ";
			}
			$sql = " AND (".implode(' OR ',$sqls).")";
			
    		return $sql;
    	}
	}

	public function onFormSave($content,$field)
	{
		return null;
	}
	
	public function onDelete($directory,$contentid = -1)
	{
	}
	
	public function getEditFieldJavaScriptDisable()
	{
		$return =  " jQ('#divMultipleSearchSelectOptions').hide();\n";
		//$return .= " jQ('#divCascadeOptions input').attr('mosReq',0);";
		return $return;
	}
	
	public function getEditFieldJavaScriptActive()
	{
       	$return = " disableAll();";
		ob_start();
		?>
		elem=getObject('divValues');
        elem.style.visibility = 'visible';
        elem.style.display = 'block';
        elem=getObject('divPlaceholder');
        elem.style.visibility = 'visible';
        elem.style.display = 'block';
        if (elem=getObject('vNames[0]')) {
          elem.setAttribute('mosReq',1);
        }
        if (elem=getObject('vValues[0]')) {
		  elem.setAttribute('mosReq',1);
		}
		<?php
		$return .= ob_get_clean();
       	$return .= " jQ('#divMultipleSearchSelectOptions').show();\n";
		return $return; 
	}

	public function getEditFieldOptions($fieldid)
	{
		$this->_db->setQuery("SELECT options FROM #__adsmanager_fields WHERE fieldid = '$fieldid'");
		$options = $this->_db->loadResult();
		
		$options = json_decode($options);
		if ($options == null)
			$options = new stdClass();
			
		ob_start();
		if (!isset($options->fieldnames)) {
			$options->fieldnames="ad_headline,ad_text";
		}
		?>
		<div id='divMultipleSearchSelectOptions'>
			<?php echo JText::_('ADSMANAGER_MULTIPLE_SEARCH_FIELDNAMES')?> <input type="text" name="multiplesearch_fieldnames" value="<?php echo htmlspecialchars($options->fieldnames);?>"/> 
		</div>
		<?php
		$return = ob_get_contents();
		ob_end_clean();
		return $return;
	}

	public function saveFieldOptions($field)
	{
		$this->install();
		
		$post = JRequest::get( 'post' );
		$fieldNames  = @$post['vNames'];
		$fieldValues = @$post['vValues'];
		
		if($field->fieldid > 0) {
			$this->_db->setQuery( "SELECT * FROM #__adsmanager_field_values"
					. " WHERE fieldid='".(int)$field->fieldid."'" );
			$existingvalues = $this->_db->loadObjectList('fieldvalue');
		} else {
			$existingvalues = array();
		}

		$i=0;$j=0;
		while(isset($fieldNames[$i])){
			$fieldName  = trim($fieldNames[$i]);
			$fieldValue = trim($fieldValues[$i]);
			$i++;

			if ($fieldName!=null) {
				$obj = new stdClass();
				$obj->fieldtitle = $fieldName;
				$obj->fieldvalue = $fieldValue;
				$obj->ordering = $j;
				$obj->fieldid = $field->fieldid;
				$listnewvalues[] = $this->_db->Quote($fieldValue);

				if (isset($existingvalues[$fieldValue])) {
					$obj->fieldvalueid = $existingvalues[$fieldValue]->fieldvalueid;
					$this->_db->updateObject('#__adsmanager_field_values',$obj,'fieldvalueid');

				} else {
					$this->_db->insertObject('#__adsmanager_field_values',$obj);
				}
				$j++;
			}
		}

		//If they was previous values then erase old values no more present
		if (count($listnewvalues) >0 && count($existingvalues) > 0) {
			$this->_db->setQuery("DELETE FROM #__adsmanager_field_values 
							      WHERE fieldid = ".$field->fieldid." 
					              AND fieldvalue NOT IN (".implode(',',$listnewvalues).")");
			$this->_db->query();
			
		}

		$fieldnames  = JRequest::getVar('multiplesearch_fieldnames',array());
		
		$options = array();
		$options["fieldnames"] = $fieldnames;


		return $options;
	}
	
	public function getFieldName()
	{
		return "MultipleSearchSelect";
	}
	
	public function install()
	{
	}
	
	public function uninstall()
	{	
	}
	
	public function __construct()
	{
		$db	= JFactory::getDBO();
		$this->_db = $db;
	}
}


$plugins["multiplesearchselect"] = new AdsManagerMultipleSearchSelectPlugin();
