<?php
/**
 *  @package	PaidSystem
 *  @copyright	Copyright (C) 2010-2014 Juloa.com. All rights reserved.
 *  @license    GNU General Public License version 3, or later
 */
defined('_JEXEC') or die('Restricted access');
 jimport( 'joomla.registry.registry' );

class plgAcymailingAdsmanager extends JPlugin
{

	var $categories;
	//Will store the fields displayed for the intro
	var $fieldsintro = array();
	//Will store the fields displayed for the full detail view
	var $fieldsfull = array();
	//Store the language here
	var $sobiTrans = array();

  function __construct(&$subject, $config){
      parent::__construct($subject, $config);
      if(!isset($this->params)){
        $plugin = JPluginHelper::getPlugin('acymailing', 'adsmanager');
      	if (version_compare(JVERSION,'1.7.0','<')) {
             $this->params = new JParameter( $plugin->params );
        }else{
             $this->params = new JRegistry( $plugin->params );
        }
      }
   }

   function acymailing_getPluginType() {

     $onePlugin = new stdClass();
     $onePlugin->name = 'Adsmanager';
     $onePlugin->function = 'acymailingadsmanager_show';
     $onePlugin->help = 'plugin-adsmanager';

     return $onePlugin;
   }

   function acymailingadsmanager_show(){
    $app = JFactory::getApplication();

    $pageInfo = null;

    $paramBase = ACYMAILING_COMPONENT.'.adsmanager';
    $pageInfo = new stdClass();
    $pageInfo->filter = new stdClass();
    $pageInfo->filter->order = new stdClass();
    $pageInfo->filter->order->value = $app->getUserStateFromRequest( $paramBase.".filter_order", 'filter_order',	'a.id','cmd' );
    $pageInfo->filter->order->dir	= $app->getUserStateFromRequest( $paramBase.".filter_order_Dir", 'filter_order_Dir',	'desc',	'word' );
    $pageInfo->search = $app->getUserStateFromRequest( $paramBase.".search", 'search', '', 'string' );
    $pageInfo->search = JString::strtolower( $pageInfo->search );
    $pageInfo->filter_cat = $app->getUserStateFromRequest( $paramBase.".filter_cat", 'filter_cat','','int' );
    $pageInfo->contenttype = $app->getUserStateFromRequest( $paramBase.".contenttype", 'contenttype','|type:short','string' );
    $pageInfo->author = $app->getUserStateFromRequest( $paramBase.".author", 'author','','string' );
    $pageInfo->titlelink = $app->getUserStateFromRequest( $paramBase.".titlelink", 'titlelink','|link','string' );
    $pageInfo->lang = $app->getUserStateFromRequest( $paramBase.".lang", 'lang','','string' );
    $pageInfo->pict = $app->getUserStateFromRequest( $paramBase.".pict", 'pict','thumb','string' );
	$pageInfo->autotitlelink = $app->getUserStateFromRequest( $paramBase.".autotitlelink", 'autotitlelink','|link','string' );
	$pageInfo->autoimages = $app->getUserStateFromRequest( $paramBase.".autoimages", 'autoimages','|images','string' );
	$pageInfo->automaxvalue = $app->getUserStateFromRequest( $paramBase.".max", 'max','','int' );
	$pageInfo->contentfilter = $app->getUserStateFromRequest( $paramBase.".contentfilter", 'contentfilter','|filter:created','string' );
	$pageInfo->contentorder = $app->getUserStateFromRequest( $paramBase.".contentorder", 'contentorder','|order:id','string' );
	$pageInfo->autocontenttype = $app->getUserStateFromRequest( $paramBase.".autocontenttype", 'autocontenttype','|type:intro','string' );

	$pageInfo->limit = new stdClass();
    $pageInfo->limit->value = $app->getUserStateFromRequest( $paramBase.'.list_limit', 'limit', $app->getCfg('list_limit'), 'int' );
    $pageInfo->limit->start = $app->getUserStateFromRequest( $paramBase.'.limitstart', 'limitstart', 0, 'int' );

    $picts = array();
    $picts[] = JHTML::_('select.option', "image",JText::_('JOOMEXT_YES'));
    $picts[] = JHTML::_('select.option', "thumb",JText::_('RESIZED')); 
    $picts[] = JHTML::_('select.option', "0",JText::_('JOOMEXT_NO'));

    $db = JFactory::getDBO();

    $searchFields = array('a.id','a.ad_headline');

    if(!empty($pageInfo->search)){
      $searchVal = '\'%'.$db->getEscaped($pageInfo->search,true).'%\'';
      $filters[] = implode(" LIKE $searchVal OR ",$searchFields)." LIKE $searchVal";
    }

    if($this->params->get('displayart','all') == 'onlypub'){
      $filters[] = "a.published = 1";
    }

    $query = 'SELECT SQL_CALC_FOUND_ROWS a.id,a.ad_headline ';
    $query .= 'FROM `#__adsmanager_ads` as a INNER JOIN `#__adsmanager_adcat` as b ON a.id = b.adid';
    
    if(!empty($pageInfo->filter_cat)) {
	    $catid = $pageInfo->filter_cat;
	    $db->setQuery( " SELECT c.id, c.name,c.parent ".
					   " FROM #__adsmanager_categories as c ".
					   " WHERE c.published = 1 ORDER BY c.parent,c.ordering");
						 
		$listcats = $db->loadObjectList();
		$list[] = $catid;
		$this->_recurseSearch($listcats,$list,$catid);
		$listids = implode(',', $list);
	    
	    $filters[] = "b.catid IN ($listids) ";
    }

    if(!empty($filters)){
      $query .= ' WHERE ('.implode(') AND (',$filters).')';
    }

    $query .=' GROUP BY a.id';

    if(!empty($pageInfo->filter->order->value)){
      $query .= ' ORDER BY '.$pageInfo->filter->order->value.' '.$pageInfo->filter->order->dir;
    }

    $db->setQuery($query,$pageInfo->limit->start,$pageInfo->limit->value);
    $rows = $db->loadObjectList();

    if(!empty($pageInfo->search)){
      $rows = acymailing_search($pageInfo->search,$rows);
    }

    $db->setQuery('SELECT FOUND_ROWS()');
    //$pageInfo = new stdClass();
    $pageInfo->elements = new stdClass();
    $pageInfo->elements->total = $db->loadResult();
    $pageInfo->elements->page = count($rows);

   /* $db->setQuery('SELECT a.id, a.name, b.parentid FROM #__adsmanager_categories as a LEFT JOIN #__adsmanager_adcat as b on a.id=b.catid');
    $categories = $db->loadObjectList();*/
    $db->setQuery( " SELECT c.* FROM #__adsmanager_categories as c ".
				   " WHERE 1 ORDER BY c.parent,c.ordering");
	$categories = $db->loadObjectList();

    $this->cats = array();
    foreach($categories as $oneCat){
		$this->cats[intval($oneCat->parent)][] = $oneCat;
	}
    $this->_handleChildrens(isset($this->cats[0]) ? '0' : '1');

    //Let's order the categories

	$categories = $this->categories;

    $allCats = new stdClass();
    $allCats->id=0;
    $allCats->name = JText::_('ALL');

    array_unshift($categories,$allCats);

	$contenttype = array();
	$contenttype[] = JHTML::_('select.option', "|type:title",JText::_('TITLE_ONLY'));
	$contenttype[] = JHTML::_('select.option', "|type:short",JText::_('JOOMEXT_TEXT'));
	$contenttype[] = JHTML::_('select.option', "|type:full",JText::_('FULL_TEXT'));


    jimport('joomla.html.pagination');
    $pagination = new JPagination( $pageInfo->elements->total, $pageInfo->limit->start, $pageInfo->limit->value );

    $tabs = acymailing_get('helper.acytabs');
    echo $tabs->startPane( 'adsmanager_tab');
    echo $tabs->startPanel( JText::_( 'TAG_ELEMENTS' ), 'adsmanager_content');

  ?>
    <br style="font-size:1px"/>
    <script language="javascript" type="text/javascript">
    <!--
      var selectedContents = new Array();
      function applyContent(contentid,rowClass){
        if(selectedContents[contentid]){
          window.document.getElementById('content'+contentid).className = rowClass;
          delete selectedContents[contentid];
        }else{
          window.document.getElementById('content'+contentid).className = 'selectedrow';
          selectedContents[contentid] = 'content';
        }

        updateTag();
      }

      function updateTag(){
        var tag = '';
        var otherinfo = '';
        for(var i=0; i < document.adminForm.contenttype.length; i++){
           if (document.adminForm.contenttype[i].checked){ selectedtype = document.adminForm.contenttype[i].value; otherinfo += document.adminForm.contenttype[i].value; }
        }
        for(var i=0; i < document.adminForm.titlelink.length; i++){
           if (document.adminForm.titlelink[i].checked){ otherinfo += document.adminForm.titlelink[i].value; }
        }
        if(selectedtype != '|type:title'){
          for(var i=0; i < document.adminForm.pict.length; i++){
             if (document.adminForm.pict[i].checked){ otherinfo += '|pict:'+document.adminForm.pict[i].value; }
          }
        }

        if(window.document.getElementById('jflang')  && window.document.getElementById('jflang').value != ''){
          otherinfo += '|lang:';
          otherinfo += window.document.getElementById('jflang').value;
        }

        for(var i in selectedContents){
          if(selectedContents[i] == 'content'){
            tag = tag + '{adsmanager:'+i+otherinfo+'}<br/>';
          }
        }
        setTag(tag);
      }
    //-->
    </script>
    <table width="100%" class="adminform">
      <tr>
        <td>
          <?php echo JText::_('DISPLAY');?>
        </td>
        <td colspan="2">
        	<?php echo JHTML::_('select.radiolist', $contenttype, 'contenttype' , 'size="1" onclick="updateTag();"', 'value', 'text', $pageInfo->contenttype); ?>
        </td>
        <td>

        </td>
      </tr>
      <tr>
        <td>
        <?php echo JText::_('CLICKABLE_TITLE'); ?>
         </td>
         <td>
           <?php $titlelinkType = acymailing_get('type.titlelink'); echo $titlelinkType->display('titlelink',$pageInfo->titlelink);?>
        </td>
        <td>

         </td>
         <td>

        </td>
      </tr>
      <tr>
        <td><?php echo JText::_('DISPLAY_PICTURES'); ?></td>
        <td><?php echo JHTML::_('select.radiolist', $picts, 'pict' , 'size="1" onclick="updateTag();"', 'value', 'text', $pageInfo->pict); ?></td>
        <td></td>
        <td></td>
      </tr>
    </table>
    <table>
      <tr>
        <td width="100%">
          <?php echo JText::_( 'JOOMEXT_FILTER' ); ?>:
          <input type="text" name="search" id="acymailingsearch" value="<?php echo $pageInfo->search;?>" class="text_area" onchange="document.adminForm.submit();" />
          <button onclick="this.form.submit();"><?php echo JText::_( 'JOOMEXT_GO' ); ?></button>
          <button onclick="document.getElementById('acymailingsearch').value='';this.form.submit();"><?php echo JText::_( 'JOOMEXT_RESET' ); ?></button>
        </td>
        <td nowrap="nowrap">
          <?php echo JHTML::_('select.genericlist', $categories, 'filter_cat', 'class="inputbox" size="1" onchange="document.adminForm.submit( );"', 'id', 'name', (int) $pageInfo->filter_cat );?>
        </td>
      </tr>
    </table>

    <table class="adminlist" cellpadding="1" width="100%">
      <thead>
        <tr>
          <th class="title">
            <?php echo JHTML::_('grid.sort', JText::_( 'FIELD_TITLE'), 'a.ad_headline', $pageInfo->filter->order->dir,$pageInfo->filter->order->value ); ?>
          </th>
          <th class="title titleid">
            <?php echo JHTML::_('grid.sort',   JText::_( 'ACY_ID' ), 'a.id', $pageInfo->filter->order->dir, $pageInfo->filter->order->value ); ?>
          </th>
        </tr>
      </thead>
      <tfoot>
        <tr>
          <td colspan="2">
            <?php echo $pagination->getListFooter(); ?>
            <?php echo $pagination->getResultsCounter(); ?>
          </td>
        </tr>
      </tfoot>
      <tbody>
        <?php
          $k = 0;
          for($i = 0,$a = count($rows);$i<$a;$i++){
            $row = $rows[$i];
        ?>
          <tr id="content<?php echo $row->id?>" class="<?php echo "row$k"; ?>" onclick="applyContent(<?php echo $row->id.",'row$k'"?>);" style="cursor:pointer;">
            <td>
            <?php
              echo  $row->ad_headline;
            ?>
            </td>
            <td align="center">
              <?php echo $row->id; ?>
            </td>
          </tr>
        <?php
            $k = 1-$k;
          }
        ?>
      </tbody>
    </table>
    <input type="hidden" name="boxchecked" value="0" />
    <input type="hidden" name="filter_order" value="<?php echo $pageInfo->filter->order->value; ?>" />
    <input type="hidden" name="filter_order_Dir" value="<?php echo $pageInfo->filter->order->dir; ?>" />
  <?php
  echo $tabs->endPanel();
  echo $tabs->startPanel( JText::_( 'TAG_CATEGORIES' ), 'adsmanager_auto');

  $ordering = array();
  $ordering[] = JHTML::_('select.option', "|order:id,DESC",JText::_('ACY_ID'));
  $ordering[] = JHTML::_('select.option', "|order:title,ASC",JText::_('FIELD_TITLE'));

    $type = JRequest::getString('type');

  ?>
    <br style="font-size:1px"/>
    <script language="javascript" type="text/javascript">
    <!--
      var selectedCat = new Array();
      function applyAuto(catid,rowClass){
        if(selectedCat[catid]){
          window.document.getElementById('cat'+catid).className = rowClass;
          delete selectedCat[catid];
        }else{
          window.document.getElementById('cat'+catid).className = 'selectedrow';
          selectedCat[catid] = 'selectedone';
        }

        updateAutoTag();
      }

      function updateAutoTag(){
        tag = '{autoadsmanager:';

        for(var icat in selectedCat){
          if(selectedCat[icat] == 'selectedone'){
            tag += icat+'-';
          }
        }

        if(document.adminForm.min_ad && document.adminForm.min_ad.value && document.adminForm.min_ad.value!=0){ tag += '|min:'+document.adminForm.min_ad.value; }
        if(document.adminForm.max_ad.value && document.adminForm.max_ad.value!=0){ tag += '|max:'+document.adminForm.max_ad.value; }
        if(document.adminForm.contentorder.value){ tag += document.adminForm.contentorder.value; }
        if(document.adminForm.contentfilter && document.adminForm.contentfilter.value){ tag += document.adminForm.contentfilter.value; }
        if(document.adminForm.meta_ad && document.adminForm.meta_ad.value){ tag += '|meta:'+document.adminForm.meta_ad.value; }

        for(var i=0; i < document.adminForm.contenttypeauto.length; i++){
           if (document.adminForm.contenttypeauto[i].checked){selectedtype = document.adminForm.contenttypeauto[i].value; tag += document.adminForm.contenttypeauto[i].value; }
        }
        for(var i=0; i < document.adminForm.titlelinkauto.length; i++){
           if (document.adminForm.titlelinkauto[i].checked){ tag += document.adminForm.titlelinkauto[i].value; }
        }
        if(selectedtype != '|type:title'){
          for(var i=0; i < document.adminForm.pictauto.length; i++){
             if (document.adminForm.pictauto[i].checked){ tag += '|pict:'+document.adminForm.pictauto[i].value; }
          }
        }
        if(window.document.getElementById('jflangauto')  && window.document.getElementById('jflangauto').value != ''){
          tag += '|lang:';
          tag += window.document.getElementById('jflangauto').value;
        }

        tag += '}';

        setTag(tag);
      }
    //-->
    </script>
    <table width="100%" class="adminform">
      <tr>
        <td>
          <?php echo JText::_('DISPLAY');?>
        </td>
        <td colspan="2">
        	<?php echo JHTML::_('select.radiolist', $contenttype, 'contenttypeauto' , 'size="1" onclick="updateAutoTag();"', 'value', 'text', $pageInfo->autocontenttype); ?>
        </td>
        <td>

        </td>
      </tr>
      <tr>
        <td>
        <?php echo JText::_('CLICKABLE_TITLE'); ?>
         </td>
         <td>
           <?php $titlelinkType = acymailing_get('type.titlelink'); $titlelinkType->onclick = "updateAutoTag();"; echo $titlelinkType->display('titlelinkauto','|link');?>
        </td>
        <td>

         </td>
         <td>

        </td>
      </tr>
      <tr>
        <td><?php echo JText::_('DISPLAY_PICTURES'); ?></td>
        <td><?php echo JHTML::_('select.radiolist', $picts, 'pictauto' , 'size="1" onclick="updateAutoTag();"', 'value', 'text', "thumb"); ?></td>
        <td></td>
        <td></td>
      </tr>
      <tr>
        <td>
        <?php echo JText::_('MAX_ARTICLE'); ?>
         </td>
         <td>
           <input name="max_ad" size="10" value="20" onchange="updateAutoTag();"/>
        </td>
        <td>
        <?php echo JText::_('ACY_ORDER'); ?>
         </td>
         <td>
           <?php echo JHTML::_('select.genericlist', $ordering, 'contentorder' , 'size="1" onchange="updateAutoTag();"', 'value', 'text'); ?>
        </td>
      </tr>
      <?php if($type == 'autonews') { ?>
      <tr>
        <td>
        <?php 	echo JText::_('MIN_ARTICLE'); ?>
         </td>
         <td>
         <input name="min_ad" size="10" value="1" onchange="updateAutoTag();"/>
        </td>
        <td>
        <?php echo JText::_('FILTER'); ?>
         </td>
         <td>
           <?php $filters = array(); $filters[] = JHTML::_('select.option', "",JText::_('ALL')); $filters[] = JHTML::_('select.option', "|filter:created",JText::_('ONLY_NEW_CREATED'));
				echo JHTML::_('select.genericlist', $filters, 'contentfilter' , 'size="1" onclick="updateAutoTag();"', 'value', 'text', '|filter:created'); ?>
        </td>
      </tr>
      <?php } ?>
    </table>

    <table class="adminlist" cellpadding="1" width="100%">
    <?php $k=0; foreach($this->categories as $oneCat){
       if(empty($oneCat->id)) continue;
      ?>
      <tr id="cat<?php echo $oneCat->id ?>" class="<?php echo "row$k"; ?>" onclick="applyAuto(<?php echo $oneCat->id ?>,'<?php echo "row$k" ?>');" style="cursor:pointer;">
        <td>
        <?php
          echo $oneCat->name;
        ?>
        </td>
      </tr>
    <?php $k = 1 - $k; } ?>
    </table>
  <?php

    echo $tabs->endPanel();
    echo $tabs->endPane();
  //End of the function
   }

   function acymailing_replacetags(&$email){
    $this->_replaceAuto($email);
     $this->_replaceAds($email);
   }

   function _replaceAds(&$email){
    $match = '#{adsmanager:(.*)}#Ui';
    $variables = array('subject','body','altbody');
    $found = false;
    foreach($variables as $var){
      if(empty($email->$var)) continue;
      $found = preg_match_all($match,$email->$var,$results[$var]) || $found;
      //we unset the results so that we won't handle it later... it will save some memory and processing
      if(empty($results[$var][0])) unset($results[$var]);
    }

    //If we didn't find anything...
    if(!$found) return;

    //We will need the mailer class as well
    $mailerHelper = acymailing_get('helper.mailer');

    $htmlreplace = array();
    $textreplace = array();
    $subjectreplace = array();
    foreach($results as $var => $allresults){
      foreach($allresults[0] as $i => $oneTag){
        //Don't need to process twice a tag we already have!
        if(isset($htmlreplace[$oneTag])) continue;

        $ad = $this->_replaceContent($allresults,$i);
        $htmlreplace[$oneTag] = $ad;
        $textreplace[$oneTag] = $mailerHelper->textVersion($ad);
        $subjectreplace[$oneTag] = strip_tags($ad);
      }
    }

    $email->body = str_replace(array_keys($htmlreplace),$htmlreplace,$email->body);
    $email->altbody = str_replace(array_keys($textreplace),$textreplace,$email->altbody);
    $email->subject = str_replace(array_keys($subjectreplace),$subjectreplace,$email->subject);
   }
   
   function _displayFull($tag,$link,$styleTitle,$styleTitleEnd,$ad,$helper,$fields,$conf) {
	   if(!empty($tag->link)){
	        $title = '<a href="'.$link.'" ';
	        $title .= 'target="_blank" >'.$styleTitle.$helper->showFieldValue($ad,$fields['ad_headline']).$styleTitleEnd.'</a>';
	   }else{
	        $title = $styleTitle.$helper->showFieldValue($ad,$fields['ad_headline']).$styleTitleEnd;
	   }
       echo '<h2 class="acymailing_title">'.$title.'</h2>';
       $imgpath = $this->_getimagepath($ad,"thumb");
       echo '<img src="'.$imgpath.'" style="float:right;margin:5px" />';
       echo $helper->showFieldValue($ad,$fields['ad_text'])."<br/>";
       foreach($fields as $name => $field) {
       		if (($name != 'ad_headline')&&($name != 'ad_text')) {
       			$c = $helper->showFieldValue($ad,$field);
       			if ($c != "") {
       				$title = $helper->showFieldTitle(@$ad->catid,$field);
       				if ($title != "")
       					echo htmlspecialchars($title).": ";
       				echo "$c<br/>";
       			}
       		}
       }
   }

   function _replaceContent(&$results,$i){
    //1 : Transform the tag properly...
    $arguments = explode('|',strip_tags($results[1][$i]));
    $tag = new stdClass();
    $tag->id = (int) $arguments[0];
    for($i=1,$a=count($arguments);$i<$a;$i++){
      $args = explode(':',$arguments[$i]);
      if(isset($args[1])){
	    $test = $args[0];
        $tag->$test = $args[1];
      }else{
		$test = $args[0];
        $tag->$test = true;
      }
    }

    //2 : Load the Joomla ad... with the author, the section and the categories to create nice links
    $query = 'SELECT a.*,b.catid FROM #__adsmanager_ads as a INNER JOIN `#__adsmanager_adcat` as b ON a.id = b.adid WHERE a.id = '.$tag->id.' LIMIT 1';

    $db = JFactory::getDBO();
    $db->setQuery($query);
    $ad = $db->loadObject();
    
    $ad->images = json_decode($ad->images);

    $result = '';

    //In case of we could not load the ad for any reason...
    if(empty($ad)){
      $app = JFactory::getApplication();
      if($app->isAdmin()){
        $app->enqueueMessage('The ad "'.$tag->id.'" could not be loaded','notice');
      }
      return $result;
    }
    
    //Add the title with a link or not on it.
    //If we add a link, we add in the same time a name="content-CONTENTID" so that we will be able to parse the content to create a nice summary
    $styleTitle = '';
    $styleTitleEnd = '';
    if($tag->type != "title"){
      $styleTitle = '<h2 class="acymailing_title">';
      $styleTitleEnd = '</h2>';
    }
    
    $link = 'index.php?option=com_adsmanager&view=details&catid='.$ad->catid.'&id='.$tag->id;
   	$link = acymailing_frontendLink($link);

    if(!empty($tag->link)){
        $title = '<a href="'.$link.'" ';
        $title .= 'target="_blank" >'.$styleTitle.$ad->ad_headline.$styleTitleEnd.'</a>';
    }else{
        $title = $styleTitle.$ad->ad_headline.$styleTitleEnd;
    }
    
    $db->setQuery( "SELECT * FROM #__adsmanager_config");
	$conf = $db->loadObject();
    $nbimages = $conf->nb_images;
    
    switch($tag->type) {
    	
    	case "title":
    		$result .= $title;
    		break;
    		
    	case "short":
    	   $result .= $title;
		   $imgpath = $this->_getimagepath($ad,$tag->pict);
		   if(!empty($tag->pict) AND ($imgpath != null)){
					$result .=  '<img src="'.$imgpath.'" style="float:right;margin:5px" />';
		   }
		   $result .= $ad->ad_text;
    	   break;
    		
    	case "full":
   			$db->setQuery( "SELECT * FROM #__adsmanager_field_values ORDER by ordering ");
			$fieldvalues = $db->loadObjectList();
			if ($db -> getErrorNum()) {
				echo $db -> stderr();
				return false;
			}
			
			$field_values = array();
			// first pass - collect children
			if (isset($fieldvalues))
			{
				foreach ($fieldvalues as $v ) {
					$pt 	= $v->fieldid;
					$list 	= @$field_values[$pt] ? $field_values[$pt] : array();
					array_push( $list, $v );
					$field_values[$pt] = $list;
				}
			}
			
			$db->setQuery( "SELECT * FROM #__adsmanager_fields as f WHERE f.published = 1 ORDER by f.ordering ASC");
			$fields = $db->loadObjectList('name');
			foreach($fields as $key => $field) {
				$fields[$key]->options = json_decode($field->options);
			}
			
    		$plugins = null;
			
			if(file_exists(JPATH_ROOT . "/images/com_adsmanager/plugins/")) { 
				$path = JPATH_ROOT."/images/com_adsmanager/plugins/";
				$handle = opendir( $path );
				while ($file = readdir($handle)) {
					$dir = $path.'/'.$file;
					if (is_dir($dir))
					{
						if (($file != ".") && ($file != "..")) {
							require_once($path.'/'.$file.'/plug.php');
						}
					}
				}
			
				closedir($handle);
			}
			
			require_once(JPATH_ROOT.'/components/com_adsmanager/helpers/field.php');
			$helper = new JHTMLAdsmanagerField($conf,$field_values,"1",$plugins,"",JURI::root());
			
			$lang = JFactory::getLanguage();
			$lang->load("com_adsmanager",JPATH_ROOT);
			
		    if(file_exists(ACYMAILING_MEDIA.'plugins'.DS.'adsmanager.php')){
		      ob_start();
		      require(ACYMAILING_MEDIA.'plugins'.DS.'adsmanager.php');
		      $result = ob_get_clean();
		    } else {
		    	ob_start();
		    	$this->_displayFull($tag,$link,$styleTitle,$styleTitleEnd,$ad,$helper,$fields,$conf);
		    	$result = ob_get_clean();
		    }
    }
    $result = '<div class="acymailing_content">'.$result.'</div>';
    
    //Should we remove the JS?
    if($tag->type != 'title' AND $this->params->get('removejs','yes') == 'yes'){
      $result = $this->_removeJS($result);
    }

    return $result;
  }
  
  function _getimagepath($content,$thumb="thumb") {
  	$baseurl =  JURI::root();
  	if (count($content->images) > 0) {
  		if ($thumb == "thumb") {
  			return JURI::root()."images/com_adsmanager/contents/".$content->images[0]->thumbnail;
  		} else {
  			return JURI::root()."images/com_adsmanager/contents/".$content->images[0]->image;
  		}
  	}
  	return null;
  }

  function _replaceAuto(&$email){
    $this->acymailing_generateautonews($email);

    if(!empty($this->tags)){
      $email->body = str_replace(array_keys($this->tags),$this->tags,$email->body);
      if(!empty($email->altbody)) $email->altbody = str_replace(array_keys($this->tags),$this->tags,$email->altbody);
      foreach($this->tags as $tag => $result){
        $email->subject = str_replace($tag,strip_tags(str_replace('</tr><tr>',' | ',$result)),$email->subject);
      }
    }
  }

  function acymailing_generateautonews(&$email){

    $return = new stdClass();
    $return->status = true;
    $return->message = '';

    $time = time();


    //Check if we should generate the SmartNewsletter or not...
    $match = '#{autoadsmanager:(.*)}#Ui';
    $variables = array('subject','body','altbody');
    $found = false;
    foreach($variables as $var){
      if(empty($email->$var)) continue;
      $found = preg_match_all($match,$email->$var,$results[$var]) || $found;
      //we unset the results so that we won't handle it later... it will save some memory and processing
      if(empty($results[$var][0])) unset($results[$var]);
    }

    //If we didn't find anything... so we won't try to stop the generation
    if(!$found) return $return;

    $this->tags = array();
    $db = JFactory::getDBO();

    foreach($results as $var => $allresults){
      foreach($allresults[0] as $i => $oneTag){
        if(isset($this->tags[$oneTag])) continue;

        $arguments = explode('|',strip_tags($allresults[1][$i]));
        //The first argument is a list of sections and cats...
        $allcats = explode('-',$arguments[0]);
        $parameter = new stdClass();
        for($i=1;$i<count($arguments);$i++){
          $args = explode(':',$arguments[$i]);
          $arg0 = $args[0];
          if(isset($args[1])){
            $parameter->$arg0 = $args[1];
          }else{
            $parameter->$arg0 = true;
          }
        }
        //Load the ads based on all arguments...
        $selectedArea = array();
        foreach($allcats as $oneCat){
          if(empty($oneCat)) continue;
          $selectedArea[] = (int) $oneCat;
        }
        $query = 'SELECT DISTINCT a.id FROM `#__adsmanager_ads` as a LEFT JOIN `#__adsmanager_adcat` as b ON a.id = b.adid';
        $where = array();
        if(!empty($selectedArea)){
          $where[] = 'b.`catid` IN ('.implode(',',$selectedArea).')';
        }

        if(!empty($parameter->filter) AND !empty($email->params['lastgenerateddate'])){
          $where[] = 'a.`date_created` >\''.date( 'Y-m-d H:i:s',$email->params['lastgenerateddate'] - date('Z')).'\'';
        }

        $where[] = 'a.`date_created` < \'' .date( 'Y-m-d H:i:s',$time - date('Z')).'\'';
        $where[] = 'a.published = 1';

        $query .= ' WHERE ('.implode(') AND (',$where).')';
        if(!empty($parameter->order)){
          $ordering = explode(',',$parameter->order);
          $query .= ' ORDER BY a.`'.acymailing_secureField($ordering[0]).'` '.acymailing_secureField($ordering[1]);
        }

        $start = '';
        if(!empty($parameter->start)) $start = intval($parameter->start).',';

        if(!empty($parameter->max)) $query .= ' LIMIT '.$start.(int) $parameter->max;
        elseif(empty($email->params['lastgenerateddate'])) $query .= ' LIMIT '.$start.'20';
        //We add a limit for the preview otherwise we could break everything

        $db->setQuery($query);
        //HACK
        //$allAds = $db->loadResultArray();
        $allAds = $db->loadAssocList();
        
        if(!empty($parameter->min) AND count($allAds)< $parameter->min){
          //We won't generate the Newsletter
          $return->status = false;
          $return->message = 'Not enough ads for the tag '.$oneTag.' : '.count($allAds).' / '.$parameter->min.' between '.acymailing_getDate($email->params['lastgenerateddate']).' and '.acymailing_getDate($time);
        }

        $stringTag = '';
        if(!empty($allAds)){
          if(file_exists(ACYMAILING_MEDIA.'plugins'.DS.'autoadsmanager.php')){
            ob_start();
            require(ACYMAILING_MEDIA.'plugins'.DS.'autoadsmanager.php');
            $stringTag = ob_get_clean();
          }else{
            //we insert the ad tag one after the other in a table as they are already sorted
            $stringTag .= '<table width="100%" border="0" cellpadding="0" cellspacing="0">';
            foreach($allAds as $oneAdId){
              $stringTag .= '<tr><td>';
              $args = array();
              $args[] = 'adsmanager:'.$oneAdId["id"];
              if(!empty($parameter->type)) $args[] = 'type:'.$parameter->type;
              if(!empty($parameter->link)) $args[] = 'link';
              if(!empty($parameter->author)) $args[] = 'author';
              if(!empty($parameter->lang)) $args[] = 'lang:'.$parameter->lang;
              if(!empty($parameter->notitle)) $args[] = 'notitle';
              if(isset($parameter->pict)) $args[] = 'pict:'.$parameter->pict;
              if(!empty($parameter->maxwidth)) $args[] = 'maxwidth:'.$parameter->maxwidth;
              if(!empty($parameter->maxheight)) $args[] = 'maxheight:'.$parameter->maxheight;
              $stringTag .= '{'.implode('|',$args).'}';
              $stringTag .= '</td></tr>';
            }
            $stringTag .= '</table>';
          }
        }

        $this->tags[$oneTag] = $stringTag;
      }
    }
    
    return $return;
  }

	function _handleChildrens($parentId=0,$level=0){
		if(!empty($this->cats[$parentId])){
			foreach($this->cats[$parentId] as $cat){
				$cat->name = str_repeat(" - - ",$level).$cat->name;
				$this->categories[] = $cat;
				$this->_handleChildrens($cat->id,$level+1);
			}
		}
	}
	
  function _removeJS($text){
    //Remove the picture... normal process
    $text = preg_replace("#(onmouseout|onmouseover|onclick|onfocus|onload|onblur) *= *\"(?:(?!\").)*\"#iU",'',$text);
    $text =  preg_replace("#< *script(?:(?!< */ *script *>).)*< */ *script *>#isU",'',$text);
    return $text;
  }
	
	function _recurseSearch ($rows,&$list,$catid){
		if(isset($rows))
		{
			foreach($rows as $row) {
				if ($row->parent == $catid)
				{
					$list[]= $row->id;
					$this->_recurseSearch($rows,$list,$row->id);
				} 
			}
		}
	}

}//endclass