<?php
/**
 *  @package	PaidSystem
 *  @copyright	Copyright (C) 2010-2014 Juloa.com. All rights reserved.
 *  @license    GNU General Public License version 3, or later
 */
// Security check to ensure this file is being included by a parent file.
defined( '_JEXEC' ) or die( 'Direct Access to this location is not allowed.' );

//require_once(JPATH_ROOT."/components/com_adsmanager/lib/core.php");

// ------------------ standard plugin initialize function - don't change -------------------
global $sh_LANG, $sefConfig ;
$shLangName = '';;
$shLangIso = '';
$title = array();
$shItemidString = '';
$dosef = shInitializePlugin( $lang, $shLangName, $shLangIso, $option);
// ------------------ standard plugin initialize function - don't change -----------------

if (!function_exists("parseJLanguage")) {
	function parseJLanguage($filename)
	{
		$version = phpversion();
	
		// Capture hidden PHP errors from the parsing.
		$php_errormsg = null;
		$track_errors = ini_get('track_errors');
		ini_set('track_errors', true);
	
		if ($version >= '5.3.1')
		{
			$contents = file_get_contents($filename);
			$contents = str_replace('_QQ_', '"\""', $contents);
			$strings = @parse_ini_string($contents);
		}
		else
		{
			$strings = @parse_ini_file($filename);
	
			if ($version == '5.3.0' && is_array($strings))
			{
				foreach ($strings as $key => $string)
				{
					$strings[$key] = str_replace('_QQ_', '"', $string);
				}
			}
		}
	
		// Restore error tracking to what it was before.
		ini_set('track_errors', $track_errors);
	
		if (!is_array($strings))
		{
			$strings = array();
		}
	
		return $strings;
	}
}

global $adsmanagerlanguages;
if (!function_exists("parseAdsmanagerLanguage")) {
	function parseAdsmanagerLanguage($langcode) {
		if (file_exists(JPATH_ROOT.'/language/'.$langcode.'/'.$langcode.'.com_adsmanager.ini'))
			return parseJLanguage(JPATH_ROOT.'/language/'.$langcode.'/'.$langcode.'.com_adsmanager.ini');
		else
			return parseJLanguage(JPATH_ROOT.'/language/en-GB/en-GB.com_adsmanager.ini');
	}
	
	jimport( 'joomla.language.language' );
	$languages = JLanguage::getKnownLanguages();

	$adsmanagerlanguages = array();
	foreach($languages as $lang) {
		$adsmanagerlanguages[substr($lang['tag'],0,strpos($lang['tag'],'-'))] = parseAdsmanagerLanguage($lang['tag']);
	}
}

if (!isset($sh_LANG)) {
	$sh_LANG = array();
}
foreach($adsmanagerlanguages as $lang => $list) {
	if (!isset($sh_LANG[$lang])) {
		$sh_LANG[$lang] = array();
	}
	$sh_LANG[$lang] =  array_merge($sh_LANG[$lang],$list);
}

// remove common URL from GET vars list, so that they don't show up as query string in the URL
shRemoveFromGETVarsList('option');
shRemoveFromGETVarsList('lang');

$l = JFactory::getLanguage();
$l->load("com_adsmanager",JPATH_ROOT);

if (!empty($Itemid))
	shRemoveFromGETVarsList('Itemid');

shRemoveFromGETVarsList('rootid');

if (!empty($limit)) 
	shRemoveFromGETVarsList('limit');
if (isset($limitstart)) {
	shRemoveFromGETVarsList('limitstart');
} else {
	// no limistart, insert one with value 0
	// to counter session-based storage of limitstart
	$limitstart = 0;
	shAddToGETVarsList( 'limitstart', $limitstart);
	shRemoveFromGETVarsList('limitstart');
}

$title[] = $sh_LANG[$shLangIso]['ADSMANAGER_SEF_ADS'];

if ((isset($catid))&&($catid != 0)) {
	$database->setQuery("SELECT c.* FROM #__adsmanager_categories as c WHERE c.published = 1 ORDER BY c.parent,c.ordering");
	$rows = $database->loadObjectList();
	if ($database->getErrorNum()) {
		echo $database->stderr();
		return false;
	}

	// establish the hierarchy of the menu
	$orderlist = array();
	$current_list = array();
	// first pass - collect children
	foreach ($rows as $v ) {
		$orderlist[$v->id] = $v;
	}
	
	$current = $catid;
	if (count($orderlist) > 0)
	{
		while(($current != 0)&&($current != -1))
		{
			$current_list[] = $orderlist[$current]->name;
			$current = $orderlist[$current]->parent;
		}
	}

	$size = count($current_list);
	for($i = $size -1;$i>0;$i--)
	{
		$title[] = strtolower($current_list[$i]);
	}
	if (count($current_list) > 0)
		$title[]= strtolower($current_list[0]);
}
shRemoveFromGETVarsList('catid');

if (isset($id)) {
	$database->setQuery("SELECT ad_headline FROM #__adsmanager_ads WHERE id=".(int)$id);
	$text = $database->loadResult();
	$text = JString::substr($text,0,40);
	//$text = strtolower(getMultiLangText2($text,$lang));
	$title[]= $id."-".$text;
	shRemoveFromGETVarsList('id');
}

if (isset($view)) {
	switch ($view) {
	
		case 'profile':
			$title[] = $sh_LANG[$shLangIso]['ADSMANAGER_SEF_PROFILE'];
			break;
		
		case 'list':
			if (isset($user)) {
				if ($user != 0)
					$title[] = $sh_LANG[$shLangIso]['ADSMANAGER_SEF_USER']."-".$user;
				else 
					$title[] = $sh_LANG[$shLangIso]['ADSMANAGER_SEF_USER'];
				shRemoveFromGETVarsList('user');
			} else if (isset($catid)) {
				
			} else {
				$title[] = $sh_LANG[$shLangIso]['ADSMANAGER_SEF_ALL_ADS'];
			}
			break;
			
		case 'myads':
			$title[] = $sh_LANG[$shLangIso]['ADSMANAGER_SEF_MY_ADS'];	
			break;
			
		case 'details':
			break;
		
		case 'rules':
			$title[] = $sh_LANG[$shLangIso]['ADSMANAGER_RULES'];
			break;
		
		case 'search':
			$title[] = $sh_LANG[$shLangIso]['ADSMANAGER_SEF_SEARCH'];
			break;
		
		case 'result':
			if (isset($sh_LANG[$shLangIso]['ADSMANAGER_SEF_RESULT']))
				$title[] = $sh_LANG[$shLangIso]['ADSMANAGER_SEF_RESULT'];
			else
				$title[] = 'ADSMANAGER_SEF_RESULT';
			break;
		
		case 'message':
			$title[] = $sh_LANG[$shLangIso]['ADSMANAGER_SEF_CONTACT'];
			break;
			
		case 'edit':
			if (!isset($id)) 
				$title[] = $sh_LANG[$shLangIso]['ADSMANAGER_SEF_WRITE'];
			else 
				$title[] = $sh_LANG[$shLangIso]['ADSMANAGER_SEF_EDIT'];
		    break;
			
		case 'expiration':
			$title[] = $sh_LANG[$shLangIso]['ADSMANAGER_SEF_EXPIRATION'];
			break;
			
		case 'front':
			break;
		
		default://login,expiration
			$title[] = $view;
			break;
	}
	
	shRemoveFromGETVarsList('view');
}

if (isset($task)) {
	switch ($task) {
	
		case 'write':
			if (!isset($view)||($view != "edit")) {
				if (!isset($id)) 
					$title[] = $sh_LANG[$shLangIso]['ADSMANAGER_SEF_WRITE'];
				else 
					$title[] = $sh_LANG[$shLangIso]['ADSMANAGER_SEF_EDIT'];
			}
			break;
		
		case 'display':
			break;
			
		case 'delete':
			$title[] = $sh_LANG[$shLangIso]['ADSMANAGER_SEF_DELETE'];
			break;
				
		default:
			$title[] = $task;
			break;
	}
	
	shRemoveFromGETVarsList('task');
}

// ------------------ standard plugin finalize function - don't change ---------------------------

if ($dosef){
	$string = shFinalizePlugin( $string, $title, $shAppendString, $shItemidString,
	(isset($limit) ? @$limit : null), (isset($limitstart) ? @$limitstart : null),
	(isset($shLangName) ? @$shLangName : null));
}
// ------------------ standard plugin finalize function - don't change ---------------------------